<?xml version="1.0" encoding="UTF-8"?>
<beans:beans
	xmlns="http://www.springframework.org/schema/mvc"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:beans="http://www.springframework.org/schema/beans"
	xmlns:context="http://www.springframework.org/schema/context"
	xmlns:mvc="http://www.springframework.org/schema/mvc"
	xsi:schemaLocation="http://www.springframework.org/schema/mvc https://www.springframework.org/schema/mvc/spring-mvc.xsd
        http://www.springframework.org/schema/beans https://www.springframework.org/schema/beans/spring-beans.xsd
        http://www.springframework.org/schema/context https://www.springframework.org/schema/context/spring-context.xsd">

	<resources mapping="/resources/**" location="/resources/"/>
    <resources mapping="/webjars/**" location="/webjars/"/>
	
	<mvc:annotation-driven />

	<context:component-scan base-package="fr.dawan.springmvc" />

    <!-- Views resolvers -->
    <!-- JSP -->
	<beans:bean id="viewResolver" class="org.springframework.web.servlet.view.InternalResourceViewResolver">
		<beans:property name="order" value="2" />
		<beans:property name="prefix" value="/WEB-INF/views/jsp/" />
		<beans:property name="suffix" value=".jsp" />
	</beans:bean>

    <!-- Freemarker -->
    <beans:bean id="freemarkerConfig" class="org.springframework.web.servlet.view.freemarker.FreeMarkerConfigurer">
        <beans:property name="templateLoaderPath" value="/WEB-INF/views/ftlh" />
	</beans:bean>
	
	<beans:bean id="viewResolverFreemarker" class="org.springframework.web.servlet.view.freemarker.FreeMarkerViewResolver">
		<beans:property name="order" value="1" />
		<beans:property name="cache" value="true" />
		<beans:property name="prefix" value="" />
		<beans:property name="suffix" value=".ftlh" />
	</beans:bean>
    
    <!-- Session3 méthode 3 -->
    <beans:bean id="user3" class="fr.dawan.springmvc.beans.Personne" scope="session"/>
    <!--Messages de validation -->
<!--     <beans:bean id="messageSource" class="org.springframework.context.support.ResourceBundleMessageSource"> -->
<!--         <beans:property name="basenames" value="ValidationMessages"/> -->
<!--     </beans:bean> -->
    
    
    <beans:bean id="mailsender" class="org.springframework.mail.javamail.JavaMailSenderImpl">
        <beans:property name="host" value="localhost"/>
        <beans:property name="port" value="250"/>
    </beans:bean>
    
    <!--  Internationalisation -->
    <beans:bean id="messageSource" class="org.springframework.context.support.ReloadableResourceBundleMessageSource">
        <beans:property name="basename" value="classpath:message"/>
        <beans:property name="defaultEncoding" value="utf-8"/>
    </beans:bean>
    
    <beans:bean id="localeResolver" class="org.springframework.web.servlet.i18n.CookieLocaleResolver">
        <beans:property name="defaultLocale" value="fr"/>
    </beans:bean>
    <!-- Theme -->
    <beans:bean id="themeSource" class="org.springframework.ui.context.support.ResourceBundleThemeSource">
        <beans:property name="basenamePrefix" value="theme-"/>
        <beans:property name="defaultEncoding" value="utf-8"/>
    </beans:bean>
    
	<beans:bean id="themeResolver" class="org.springframework.web.servlet.theme.CookieThemeResolver">
	   <beans:property name="defaultThemeName" value="default" />
	</beans:bean>
	
	<!--  Upload -->
    <beans:bean id="multipartResolver" class="org.springframework.web.multipart.commons.CommonsMultipartResolver">
        <!-- max upload size in bytes -->
		<beans:property name="maxUploadSize" value="20971520" /> <!-- 20MB -->
		<!-- max size of file in memory (in bytes) -->
		<beans:property name="maxInMemorySize" value="1048576" /> <!-- 1MB -->
    </beans:bean>
    <mvc:interceptors>
        <mvc:interceptor>
            <mvc:mapping path="/admin/**"/>
            <beans:bean id="logInterceptor" class="fr.dawan.springmvc.interceptors.LoginInterceptor"/>
        </mvc:interceptor>
        
        <!-- Interceptor internationalisation -->
        <beans:bean id="localeChangeInterceptor" class="org.springframework.web.servlet.i18n.LocaleChangeInterceptor">
            <beans:property name="paramName" value="lang"/>
        </beans:bean>
        
        <!--  Interceptor theming -->
        <beans:bean id="themeChangeInterceptor" class="org.springframework.web.servlet.theme.ThemeChangeInterceptor">
               <beans:property name="paramName" value="theme"/>
        </beans:bean>
    </mvc:interceptors>
</beans:beans>
